/* Copyright 2012 Mentor Graphics Corporation
 *            All Rights Reserved
 * 
 * THIS WORK CONTAINS TRADE SECRET
 * AND PROPRIETARY INFORMATION WHICH IS THE
 * PROPERTY OF MENTOR GRAPHICS
 * CORPORATION OR ITS LICENSORS AND IS
 * SUBJECT TO LICENSE TERMS.
 */
package demo;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.TextInputCallback;
import javax.security.auth.callback.TextOutputCallback;
import javax.security.auth.callback.UnsupportedCallbackException;
import javax.security.sasl.RealmCallback;


public class MyCallbackHandler implements CallbackHandler {
    

    private String username;
    

    private String password;
    

    public MyCallbackHandler(String username, String password) {
        this.username = username;
        this.password = password;
    }
    
    /**
     * @param callbacks
     *            Instances of Callbacks
     * @throws IOException
     *             IOException
     * @throws UnsupportedCallbackException
     *             If Callback is other than NameCallback or PasswordCallback
     */
    public void handle(Callback callbacks[]) throws IOException, UnsupportedCallbackException {
        
        for (int i = 0; i < callbacks.length; i++) {
            System.out.println(callbacks[i]);
            if (callbacks[i] instanceof NameCallback) {
                NameCallback nc = (NameCallback) callbacks[i];
                nc.setName(username);
            } else if (callbacks[i] instanceof TextOutputCallback)
            
            {
                
                // Display the message according to the specified type
                
                TextOutputCallback toc = (TextOutputCallback) callbacks[i];
                
                switch (toc.getMessageType())
                
                {
                
                case TextOutputCallback.INFORMATION:
                    
                    System.out.println(toc.getMessage());
                    
                    break;
                
                case TextOutputCallback.ERROR:
                    
                    System.out.println("ERROR: " + toc.getMessage());
                    
                    break;
                
                case TextOutputCallback.WARNING:
                    
                    System.out.println("WARNING: " + toc.getMessage());
                    
                    break;
                
                default:
                    
                    throw new IOException("Unsupported message type: " + toc.getMessageType());
                    
                }
                
            }
            
            else if (callbacks[i] instanceof PasswordCallback) {
                PasswordCallback pc = (PasswordCallback) callbacks[i];
                pc.setPassword(password.toCharArray());
            } else if (callbacks[i] instanceof RealmCallback) {
                RealmCallback rcb = (RealmCallback) callbacks[i];
                if (rcb.getText() == null)
                    rcb.setText(rcb.getDefaultText());
            } else if (callbacks[i] instanceof TextInputCallback)
            {
                
                // Prompt the user for the username
                
                TextInputCallback callback = (TextInputCallback) callbacks[i];
                
                System.err.print(callback.getPrompt());
                
                System.err.flush();
                
                callback.setText((new BufferedReader(new InputStreamReader(System.in))).readLine());
                
            }
            
            else {

                throw new UnsupportedCallbackException(callbacks[i], "Unrecognized Callback");
            }
            
        }
    }
}
