package demo;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URL;
import java.security.Security;
import java.util.concurrent.TimeUnit;

import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.EJBClientContext;
import org.jboss.ejb.client.EJBClientTransactionContext;
import org.jboss.ejb.client.remoting.IoFutureHelper;
import org.jboss.remoting3.Connection;
import org.jboss.remoting3.Endpoint;
import org.jboss.remoting3.Remoting;
import org.jboss.remoting3.RemotingOptions;
import org.jboss.remoting3.remote.HttpUpgradeConnectionProviderFactory;
import org.jboss.sasl.JBossSaslProvider;
import org.xnio.IoFuture;
import org.xnio.OptionMap;
import org.xnio.Options;
import org.xnio.OptionMap.Builder;

public class RemoteEJBClient {
    
    /**
     * User login name
     */
    private static final String USER_LOGIN_NAME = "username";
    /**
     * User password
     */
    private static final String USER_PASSWORD = "password";
    
    private static Connection connection;
    private static EJBClientContext ejbClientContext;
    private static Endpoint endpoint;
    private static void makeHTTPCall(){
    	HttpURLConnection connection = null;
    	try {
    		URL url = new URL("http://xxx.xxx.xx.xx:" + "8080");
    		connection = (HttpURLConnection) url.openConnection();
    		
    		// Call getResonseCode to see if the connection succeeded. Will throw an exception if the port is configured with SSL.
    		// If not, set the connection is not SSL-enabled
    		int httpCode = connection.getResponseCode();
    		System.out.println("*** Response Code *** " + httpCode);
    	} catch(Exception e){
    		
    	} finally {
    		if(connection != null)
    			connection.disconnect();
    	}
    }

    public static void main(String[] args) {
    	
    	makeHTTPCall();
        try {
			endpoint = Remoting.createEndpoint("default", OptionMap.EMPTY);
			 endpoint.addConnectionProvider("http-remoting", new HttpUpgradeConnectionProviderFactory(),
                     OptionMap.create(Options.SSL_ENABLED, Boolean.FALSE, Options.SASL_SERVER_AUTH,
                                      Boolean.FALSE));
			 MyCallbackHandler callbackhndlr = new MyCallbackHandler(USER_LOGIN_NAME, USER_PASSWORD);
			 // open a connection
			 URI uri = new URI("http-remoting://xxx.xxx.xx.xx:" + "8080");
			
			 Builder bld = OptionMap.builder();
			 bld.set(Options.SASL_POLICY_NOPLAINTEXT, Boolean.FALSE);
		     bld.set(Options.SASL_POLICY_NOANONYMOUS, Boolean.FALSE);
		     bld.set(RemotingOptions.HEARTBEAT_INTERVAL, 600000);
		     
			 final IoFuture<Connection> futureConnection = endpoint.connect(uri, bld.getMap(), callbackhndlr);
					 
			 connection = IoFutureHelper.get(futureConnection,5L, TimeUnit.SECONDS);
		} catch (Exception e) {
			e.printStackTrace();
			close();
			return;
		}
        
        ejbClientContext = EJBClientContext.create();
        ejbClientContext.registerConnection(connection);
        @SuppressWarnings("unused")
        final ContextSelector<EJBClientContext> previousSelector = EJBClientContext.setConstantContext(ejbClientContext);
        // setting up something for transactions
        final EJBClientTransactionContext localUserTxContext = EJBClientTransactionContext.createLocal();
        EJBClientTransactionContext.setGlobalContext(localUserTxContext);
        close();
    }
    
    public static void close(){
    	if (connection != null) {
            try {
                connection.close();
            } catch (IOException ioe) {
                System.out.println("Failed to close connection" + ioe);
            }
        }
        if (endpoint != null) {
            try {
                endpoint.close();
            } catch (IOException ioe) {
                System.out.println("Failed to close endpoint" + ioe);
            }
        }
    }
    
}
 